import java.util.*;

public class Sample {  
  public static void main(String[] args) {
    //The old Java
    List<Integer> numbers = Arrays.asList(1, 2, 3, 4, 5, 6, 7, 8, 9, 10);
    
    //imperative + object-oriented
    //imperative style: you tell what to do and also how to do it
    int result = 0;
    
    for(int e : numbers) {
      if(e % 2 == 0) {
        result += e;
      }
    }
    
    System.out.println(result);
    
    //In the new Java
    //imperative + object-oriented + functional style
    System.out.println(
      numbers.stream()
        .filter(e -> e %  2 == 0)
        .mapToInt(e -> e * 2)
        .sum());
        
    //imperative style is filled with accidental complexity
    //functional style == declarative style + higher-order function
    //declarative style: you tell what to do and *not* how to do it
    //declarative style has less accidental complexity.
  }
}